HDU 1808 Halloween treats【抽屉原理】

来源:互联网 发布:网络语言暴力案例 编辑:程序博客网 时间:2024/05/21 21:35

Halloween treats

Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 895    Accepted Submission(s): 355
Special Judge


Problem Description
Every year there is the same problem at Halloween: Each neighbour is only willing to give a certain total number of sweets on that day, no matter how many children call on him, so it may happen that a child will get nothing if it is too late. To avoid conflicts, the children have decided they will put all sweets together and then divide them evenly among themselves. From last year's experience of Halloween they know how many sweets they get from each neighbour. Since they care more about justice than about the number of sweets they get, they want to select a subset of the neighbours to visit, so that in sharing every child receives the same number of sweets. They will not be satisfied if they have any sweets left which cannot be divided. 

Your job is to help the children and present a solution. 

 

Input
The input contains several test cases. 
The first line of each test case contains two integers c and n (1 ≤ c ≤ n ≤ 100000), the number of children and the number of neighbours, respectively. The next line contains n space separated integers a1 , ... , an (1 ≤ ai ≤ 100000 ), where ai represents the number of sweets the children get if they visit neighbour i. 

The last test case is followed by two zeros. 

 

Output
For each test case output one line with the indices of the neighbours the children should select (here, index i corresponds to neighbour i who gives a total number of ai sweets). If there is no solution where each child gets at least one sweet, print "no sweets" instead. Note that if there are several solutions where each child gets at least one sweet, you may print any of them.
 

Sample Input
4 51 2 3 7 53 67 11 2 5 13 170 0
 

Sample Output
3 52 3 4
 

Source
HDOJ 2007 Summer Exercise(1)
 
Point:
1.题意:给出一串数字,选择连续的一段数字满足求和的结果可以整除给定的数 c
2.思路:数组记录前缀和(mod的结果)
   ①如果前缀和为0,则表示从1到此的和可以整除c
   ②如果出现同余,则两个位置之间的数的和可以整除c
  证明:前缀和为:
    k1*c+1...........k2*c+1
  则相减后(k2-k1)*c可以整除c


#include<iostream>#include<cstdio>#include<cstring>#include<string>#include<cmath>#include<queue>#include<stack>#include<vector>#include<map>#include<algorithm>using namespace std;#define ll long long#define ms(a,b)  memset(a,b,sizeof(a))const int M=1e5+10;const int inf=0x3f3f3f3f;const int modd=1e9+7;int a[M],mod[M];int i,j,k,n,m;int c;int main(){    while(~scanf("%d%d",&c,&n)&&n)    {        for(int i=1;i<=n;i++)scanf("%d",&a[i]);        ms(mod,-1);        int sum=0;        for(int i=1;i<=n;i++){            sum=(a[i]%c+sum)%c;            if(!sum){                printf("%d",1);                for(int j=2;j<=i;j++)printf(" %d",j);                printf("\n");                break;            }            else if(mod[sum]!=-1){                printf("%d",mod[sum]+1);                for(int j=mod[sum]+2;j<=i;j++)printf(" %d",j);                printf("\n");                break;            }            mod[sum]=i;        }    }    return 0;}


原创粉丝点击